/**
 * Nummernanzeige mit zwei Ziffern
 */
public class Nummernanzeige
{
    private int obergrenze;
    private int wert;

    /**
     * Der Konstruktor belegt die Obergrenze und setzt den Startwert
     * @param obergrenzeNeu die gewünschte Obergrenze
     */
    public Nummernanzeige(int obergrenzeNeu)
    {
        obergrenze = obergrenzeNeu;
        wert = 0;
    }

    /**
     * Gibt die eingestellte Obergrenze zurück
     * @returns eingestellte Obergrenze
     */
    public int ObergrenzeGeben()
    {
        return obergrenze;
    }

    /**
     * Gibt den aktuellen Wert zurück
     * @returns aktueller Wert
     */
    public int WertGeben()
    {
        return wert;
    }

    /**
     * Setzt den Wert der Anzeige
     * @param wertNeu neuer Wert für die Anzeige
     */
    public void WertSetzen(int wertNeu)
    {
        if (wertNeu >= 0 && wertNeu < obergrenze)
        {
            wert = wertNeu;
        }
    }

    /**
     * Erhöht den Wert der Anzeige (um 1)
     * Bei Erreichen der Obergrenze wird auf 0 zurück gesetzt.
     */
    public void Erhöhen()
    {
        wert = wert + 1;
        if (wert == obergrenze)
        {
            wert = 0;
        }
    }

    /**
     * Erniedrigt den Wert der Anzeige (um 1)
     * Bei Erreichen der 0 wird auf die Obergrenze zurück gesetzt.
     */
    public void Erniedrigen()
    {
        wert = wert - 1;
        if (wert < 0)
        {
            wert = obergrenze-1;
        }
    }
}
