// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;

/**
 * Eine Ampel verwendet zur Anzeige drei Lampen. Die Ampel verwaltet ihre Position als Ganzes, ihre Ausrichtung und auch die nach den Verkehrsregeln möglichen Ampelphasen.
 * @author Albert Wiedemann @version 1.0
 */
public class Ampel extends Ereignisbehandlung
{
    /* Mögliche Werte sind die in Deutschland erlaubten Ampelphasen grün, gelb, rot und rotgelb.*/
    protected String ampelphase;
    /* Wartezeit bis zum Weiterschalten*/
    protected int wartezeit;
    /* obere Lampe (rot)*/
    protected Lampe lampeOben;
    /* mittlere Lampe (gelb)*/
    protected Lampe lampeMitte;
    /* untere Lampe (grün)*/
    protected Lampe lampeUnten;

    /**
     * Konstruktor für Objekte der Klasse Ampel.
     */
    protected Ampel()
    {
        this(100 , 100);
    }

    /**
     * Konstruktor für Objekte der Klasse Ampel mit folgenden Eingabewerten. @param x - x-Position @param y - y-Position
     */
    protected Ampel(int x, int y)
    {
        ampelphase = "rot";
        wartezeit = 0;
        lampeOben = new Lampe ( x , y , "rot" );
        lampeMitte = new Lampe ( x , y + 20 , "gelb" );
        lampeUnten = new Lampe ( x , y + 40 , "grün" );
        lampeOben . Einschalten ( );
        lampeMitte . Ausschalten ( );
        lampeUnten . Ausschalten ( );
    }

    /**
     * Setzt die Ampel auf grün.
     */
    protected void GrünSetzen()
    {
        ampelphase = "grün";
        lampeOben . Ausschalten ( );
        lampeMitte . Ausschalten ( );
        lampeUnten . Einschalten ( );
    }

    /**
     * Setzt die Ampel auf gelb.
     */
    protected void GelbSetzen()
    {
        ampelphase = "gelb";
        lampeOben . Ausschalten ( );
        lampeMitte . Einschalten ( );
        lampeUnten . Ausschalten ( );
    }

    /**
     * Setzt die Ampel auf rot-gelb.
     */
    protected void RotgelbSetzen()
    {
        ampelphase = "rotgelb";
        lampeOben . Einschalten ( );
        lampeMitte . Einschalten ( );
        lampeUnten . Ausschalten ( );
    }

    /**
     * Setzt die Ampel auf rot.
     */
    protected void RotSetzen()
    {
        ampelphase = "rot";
        lampeOben . Einschalten ( );
        lampeMitte . Ausschalten ( );
        lampeUnten . Ausschalten ( );
    }

    /**
     * Schaltet die Ampelphasen in der Reihenfolge rot, rotgelb, grün, gelb
     */
    protected void Weiterschalten()
    {
        if (ampelphase == "rot") {
            RotgelbSetzen ( );
        }
        else {
            if (ampelphase == "rotgelb") {
                GrünSetzen ( );
            }
            else {
                if (ampelphase == "grün") {
                    GelbSetzen ( );
                }
                else {
                    RotSetzen ( );
                }
            }
        }
    }

    /**
     * Schaltet zur gegebenen Zeit die Ampel weiter
     */
    protected void TaktImpulsAusführen()
    {
        if (wartezeit <= 0) {
            Weiterschalten ( );
            if (( ampelphase == "rot" ) || ( ampelphase == "grün" )) {
                wartezeit = 30;
            }
            else {
                wartezeit = 5;
            }
        }
        else {
            wartezeit = wartezeit - 1;
        }
    }

    /**
     * Setzt die Position der Ampel. @param x x-Position @param y y-Position
     */
    protected void PositionSetzen(int x, int y)
    {
        if (x <= 800 && x >= 0 && y <= 600 && y >= 0) {
            lampeOben . PositionSetzen ( x , y );
            lampeMitte . PositionSetzen ( x , y + 20 );
            lampeUnten . PositionSetzen ( x , y + 40 );
        }
    }

    /**
     * Meldet, ob die Ampel auf grün steht. @return true, falls die Ampel grün zeigt.
     */
    protected boolean IstGrün()
    {
        return ampelphase == "grün";
    }

    /**
     * Meldet, ob die Ampel auf gelb steht. @return true, falls die Ampel gelb zeigt.
     */
    protected boolean IstGelb()
    {
        return ampelphase == "gelb";
    }
}
