// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;

/**
 * Beschreibt ein Fahrzeug.
 * @author Albert Wiedemann @version V1.0
 */
public class Fahrzeug
{
    /* Anzeigesymbol*/
    protected FahrzeugSymbol symbol;
    /* Bewegungsdaten x-Position*/
    protected int x;
    /* y-Position*/
    protected int y;
    /* Geschwindigkeit*/
    protected double v;
    /* Maximale Geschwindigkeit*/
    protected double vmax;
    /* Beschleunigung*/
    protected double a;

    /**
     * Erzeugt die Anzeige und setzt die Startdaten
     */
    protected Fahrzeug()
    {
        vmax = 13.89f;
        v = vmax;
        a = 4.0;
        x = 0;
        y = 0;
        symbol = new FahrzeugSymbol ( );
        symbol . FarbeSetzen ( ZufallsfarbeErzeugen ( ) );
        symbol . PositionSetzen ( x , y );
    }

    /**
     * Erzeugt eine zufällige Farbe für das Fahrzeug
     */
    protected String ZufallsfarbeErzeugen()
    {
        switch (( new java . util . Random ( ) ) . nextInt ( 7 )) {
            case 0 : {
                return "rot";
            }
            case 1 : {
                return "grün";
            }
            case 2 : {
                return "blau";
            }
            case 3 : {
                return "gelb";
            }
            case 4 : {
                return "cyan";
            }
            case 5 : {
                return "magenta";
            }
            case 6 : {
                return "weiss";
            }
            default : {
                return "";
            }
        }
    }

    /**
     * Setzt die Position des Fahrzeugs.
     * @param x x-Position @param y y-Position
     */
    protected void PositionSetzen(int x, int y)
    {
        this . x = x;
        this . y = y;
        symbol . PositionSetzen ( x , y );
    }

    /**
     * Fährt das Fahrzeug eine Sekunde nach oben. @param wegmax maximaler Weg bis zum nächsten Hindernis (Ampel oder VOrgänger) @param vvorg Geschwindigkeit des Vorgängerfahrzeugs bzw.der Ampel
     */
    protected void Fahren(int wegmax, double vvorg)
    {
        double weg;
        double vneu;
        weg = 0;
        /* Maximaler Weg*/
        for (int i = 0;i <= 9;i++) {
            vneu = a * 0.1 + v;
            if (vneu > vmax) {
                vneu = vmax;
            }
            weg = weg + ( vneu + v ) / 2.0 * 0.1;
            v = vneu;
        }
        weg = weg * 5;
        /* 1Px = 20cm Muss stehen bleiben Kommt zu dicht an den Vorgänger*/
        if (wegmax <= 0.0) {
            weg = 0.0;
            v = 0.0;
        }
        else if (weg >= wegmax) {
            weg = wegmax;
            /* und ist auch noch zu schnell*/
            if (v > vvorg) {
                v = vvorg;
            }
        }
        else {
            vneu = ( wegmax / 5.0 + vvorg * 1.0 - weg / 5.0 ) / 1.8;
            /* Maximale Geschwindigkeit für den Restabstand zum Vorgänger Zu schnell für den Abstand*/
            if (vneu < v) {
                v = vneu;
            }
        }
        PositionSetzen ( x , y - ( int ) weg );
    }

    /**
     * Meldet die x-Koordinate zurück @return x-Koordinate
     */
    protected int XKoordinateGeben()
    {
        return x;
    }

    /**
     * Meldet die y-Koordinate zurück @return y-Koordinate
     */
    protected int YKoordinateGeben()
    {
        return y;
    }

    /**
     * Meldet die Länge des Fahrzeugs zurück @return Länge
     */
    protected int LängeGeben()
    {
        return 22;
    }

    /**
     * Meldet die Geschwindigkeit zurück @return Geschwindigkeit
     */
    protected double GeschwindigkeitGeben()
    {
        return v;
    }

    /**
     * Entfernt das Fahrzeug aus der Anzeige
     */
    protected void Entfernen()
    {
        symbol . Entfernen ( );
    }
}
