import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Die Klasse für die Snake-Welt
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
public class GrafikWelt extends World
{
    /** Das Zeichenfenster im Hintergrund */
    HintergrundFenster fenster;
    /** Die (einzige) Instanz der Welt */
    static GrafikWelt dieWelt;

    /**
     * Legt die Welt und das Hintergrundbild an
     */
    public GrafikWelt()
    {    
        super(26, 20, 40);
        dieWelt = this; 
        fenster = new HintergrundFenster(26*40, 20*40, 40, this);
        fenster.MalflächeAktualisieren();
    }

    /**
     * Setzt den Punktestand für die Anzeige
     * @param punkte der anzuzeigende Punktestand
     */
    void PunkteSetzen(int punkte)
    {
        fenster.PunkteSetzen(punkte);
    }
    
    /**
     * Setzt die Endemeldung für die Anzeige
     * @param die anzuzeigende Endemeldung
     */
    void SonderanzeigeSetzen(String meldung)
    {
        fenster.SonderanzeigeSetzen(meldung);
    }
    
    /**
     * Setzt die Endemeldung für die Anzeige
     * @param die anzuzeigende Endemeldung
     */
    void EndemeldungSetzen(String meldung)
    {
        fenster.EndemeldungSetzen(meldung);
    }

    /**
     * Meldet die minimale X-Koordinate
     * @return minimale X-Koordinate
     */
    int XMinGeben()
    {
        return -12;
    }

    /**
     * Meldet die maximale X-Koordinate
     * @return maximale X-Koordinate
     */
    int XMaxGeben()
    {
        return 11;
    }

    /**
     * Meldet die minimale Y-Koordinate
     * @return minimale Y-Koordinate
     */
    int YMinGeben()
    {
        return -9;
    }

    /**
     * Meldet die maximale Y-Koordinate
     * @return maximale Y-Koordinate
     */
    int YMaxGeben()
    {
        return 8;
    }
    
    /**
     * Hier werden die Ereignisse an *alle* Listener weiter geleitet.
     */
    @Override public void act() 
    {
        MouseInfo mi = Greenfoot.getMouseInfo();
        if (Greenfoot.mouseClicked(null) && (mi != null))
        {
            MausGeklickt(mi.getX(), mi.getY(), mi.getClickCount());
        }
        String key = Greenfoot.getKey();
        if (key != null)
        {
            if (key.length() == 1)
            {
                char c = key.charAt(0);
                if (Greenfoot.isKeyDown("shift") && ('a' <= c) && (c <= 'z'))
                {
                    c -= 32;
                }
                TasteGedrückt (c);
            }
            else
            {
                int k = 0;
                switch (key)
                {
                    case "up":
                    k = java.awt.event.KeyEvent.VK_UP;
                    break;
                    case "down":
                    k = java.awt.event.KeyEvent.VK_DOWN;
                    break;
                    case "left":
                    k = java.awt.event.KeyEvent.VK_LEFT;
                    break;
                    case "right":
                    k = java.awt.event.KeyEvent.VK_RIGHT;
                    break;
                    default:
                    break;
                }
                if (k != 0)
                {
                    SonderTasteGedrückt (k);
                }
            }
        }
        TaktImpulsAusführen();
    }    
    
    /**
     * Wird bei jedem Taktimpuls aufgerufen
     */
    void TaktImpulsAusführen()
    {
    }

    /**
     * Wertet die Tasteneingaben aus.
     * @param welche Tastencode
     */
    void TasteGedrückt(char taste)
    {
    }

    /**
     * Wertet die Tasteneingaben aus.
     * @param welche Tastencode
     */
    void SonderTasteGedrückt(int taste)
    {
    }

    void MausGeklickt(int x, int y, int anzahl)
    {
    }

}
