// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;

/**
 * Beschreibt einen Rolladen
 * @author Albert Wiedemann @version 1.0
 */
public class Rollladen
{
    /* Name der Hauskomponente*/
    protected String name;
    /* Zustand des Rollladens*/
    protected boolean oben;
    /* Automatikbetrieb*/
    protected boolean automatik;
    /* Wert des Windsensors*/
    protected int windwert;
    /* Wert der Uhr*/
    protected int uhrzeit;
    /* Darstellungssymbol*/
    protected RollladenSymbol symbol;

    /**
     * Legt den Namen und das Darstellungssymbol fest @param namensZusatz individualler Namensteil der Komponente @param sy Darstellungssymbol @param w Windsensor @param u Uhr
     */
    protected Rollladen(String namensZusatz, RollladenSymbol sy, Windsensor w, Uhr u)
    {
        name = "Rollladen " + namensZusatz;
        oben = false;
        automatik = true;
        windwert = 0;
        uhrzeit = 0;
        symbol = sy;
        symbol.ÄnderungMelden(oben);
        w.BeobachterRegistrieren(this);
        u.BeobachterRegistrieren(this);
    }

    /**
     * Wird vom Windsensor bei einer neuen Windstärke aufgerufen @param wert die neue Windstärke
     */
    protected void WertänderungMeldenWindSensor(int wert)
    {
        windwert = wert;
        if (automatik) {
            oben = (windwert > 6) || (uhrzeit > 60000) && (uhrzeit < 200000);
            symbol.ÄnderungMelden(oben);
        }
    }

    /**
     * Wird von der Uhr bei einer neuen Uhrzeit aufgerufen @param wert die neue Uhrzeit
     */
    protected void WertänderungMeldenUhr(int wert)
    {
        uhrzeit = wert;
        if (automatik) {
            oben = (windwert > 6) || (uhrzeit > 60000) && (uhrzeit < 200000);
            symbol.ÄnderungMelden(oben);
        }
    }

    /**
     * Meldet den Zustand der Komponente @return Zustand als Zeichenkette
     */
    protected String ZustandGeben()
    {
        if (oben) {
            return "offen";
        }
        else {
            return "geschlossen";
        }
    }

    /**
     * Zieht den Rollladen dauerhaft hoch
     */
    protected void Hochziehen()
    {
        oben = true;
        automatik = false;
        symbol.ÄnderungMelden(oben);
    }

    /**
     * lässt den Rollladen dauerhaft runter
     */
    protected void Runterlassen()
    {
        oben = false;
        automatik = false;
        symbol.ÄnderungMelden(oben);
    }

    /**
     * Schaltet die Komponente auf Automatikbetrieb
     */
    protected void AutomatikAktivieren()
    {
        oben = (windwert > 6) || (uhrzeit > 60000) && (uhrzeit < 200000);
        automatik = true;
        symbol.ÄnderungMelden(oben);
    }
}
